;//********************************************
;//**  Copyright  (C)  W.ch  1999-2005       **
;//**  Web:  http://www.winchiphead.com      **
;//********************************************
;//**  DLL for USB interface chip CH341      **
;//**  CH341-DLL  V1.9                       **
;//**  Support USB chip: CH341, CH341A       **
;//**  FASM v1.73 include                    **
;//********************************************

IOCTL_CH341_COMMAND      =  0x00223cd0

mCH341_MAX_NUMBER        =  16
mCH341_PACKET_LENGTH     =  32
mCH341_PACKET_LEN_SHORT  =  8

mMAX_BUFFER_LENGTH       =  4096
mDEFAULT_BUFFER_LEN      =  1024

MAX_DEVICE_PATH_SIZE     =  128
MAX_DEVICE_ID_SIZE       =  64

CH341_DEVICE_REMOVE      =  0
CH341_DEVICE_REMOVE_PEND =  1
CH341_DEVICE_ARRIVAL     =  3

mCH341_PARA_MODE_EPP17   =  0x00
mCH341_PARA_MODE_EPP19   =  0x01
mCH341_PARA_MODE_MEM     =  0x02

;//    fn.CH341GetStatus()

mStateBitERR     =  0x00000100
mStateBitPEMP    =  0x00000200
mStateBitINT     =  0x00000400
mStateBitSLCT    =  0x00000800
mStateBitWAIT    =  0x00002000
mStateBitDATAS   =  0x00004000
mStateBitADDRS   =  0x00008000
mStateBitRESET   =  0x00010000
mStateBitWRITE   =  0x00020000
mStateBitSDA     =  0x00800000

;//  "ioCommand"  fn. CH341DriverCommand()

struct USB_SETUP_PACKET
  bmRequestType  db  0x80   ;//  :   
  bRequest       db  0x06   ;//  : 
  bValueLow      db  0      ;// 0
  bValueHigh     db  0      ;// Device/Config/Interface/Endpoint/String descr
  wIndex         dw  0      ;// 0     
  wLenght        dw  0      ;//    /
ends

struct mWIN32_COMMAND
  mFunction      dd  0      ;// (.  "mFunc_xx")
  mStatus        dd  0
  mLength        dd  0
  mSetupPkt      USB_SETUP_PACKET
  mBuffer        rb  mCH341_PACKET_LENGTH ;// =32
ends

mFuncNoOperation   =  0x00000000
mFuncGetVersion    =  0x00000001
mFuncGetConfig     =  0x00000002
mFuncSetTimeout    =  0x00000009
mFuncSetExclusive  =  0x0000000b
mFuncResetDevice   =  0x0000000c
mFuncResetPipe     =  0x0000000d
mFuncAbortPipe     =  0x0000000e
mFuncSetParaMode   =  0x0000000f
mFuncReadData0     =  0x00000010
mFuncReadData1     =  0x00000011
mFuncWriteData0    =  0x00000012
mFuncWriteData1    =  0x00000013
mFuncWriteRead     =  0x00000014
mFuncBufferMode    =  0x00000020
mFuncBufferModeDn  =  0x00000021

;// USB_SETUP_PACKET --> bRequest
;//    (6)

mUSB_CLR_FEATURE   =  0x01
mUSB_SET_FEATURE   =  0x03
mUSB_GET_STATUS    =  0x00
mUSB_SET_ADDRESS   =  0x05
mUSB_GET_DESCR     =  0x06  ;//<------- 
mUSB_SET_DESCR     =  0x07
mUSB_GET_CONFIG    =  0x08
mUSB_SET_CONFIG    =  0x09
mUSB_GET_INTERF    =  0x0a
mUSB_SET_INTERF    =  0x0b
mUSB_SYNC_FRAME    =  0x0c

mCH341_ENDP_INTER_DOWN  =  0x01
mCH341_ENDP_DATA_DOWN   =  0x02
mCH341_ENDP_INTER_UP    =  0x81
mCH341_ENDP_DATA_UP     =  0x82

mPipeDeviceCtrl  =  0x00000004
mPipeInterUp     =  0x00000005
mPipeDataUp      =  0x00000006
mPipeDataDown    =  0x00000007

mCH341_VENDOR_READ   =  0xC0
mCH341_VENDOR_WRITE  =  0x40

mCH341_PARA_INIT     =  0xB1
mCH341_I2C_STATUS    =  0x52
mCH341_I2C_COMMAND   =  0x53

mCH341_PARA_CMD_R0   =  0xAC
mCH341_PARA_CMD_R1   = 	0xAD
mCH341_PARA_CMD_W0   =  0xA6
mCH341_PARA_CMD_W1   =  0xA7
mCH341_PARA_CMD_STS  =  0xA0

mCH341A_CMD_SET_OUTPUT  =  0xA1
mCH341A_CMD_IO_ADDR     =  0xA2
mCH341A_CMD_PRINT_OUT   =  0xA3
mCH341A_CMD_SPI_STREAM  =  0xA8
mCH341A_CMD_SIO_STREAM  =  0xA9
mCH341A_CMD_I2C_STREAM  =  0xAA
mCH341A_CMD_UIO_STREAM  =  0xAB

mCH341A_I2C_CMD_X  =  0x54
mCH341A_DELAY_MS   =  0x5E
mCH341A_GET_VER    =  0x5F
mCH341A_BUF_CLEAR  =  0xB2

 mCH341_EPP_IO_MAX  =  mCH341_PACKET_LENGTH -1
mCH341A_EPP_IO_MAX  =  0xFF

mCH341A_CMD_IO_ADDR_W  =  0x00
mCH341A_CMD_IO_ADDR_R  =  0x80

mCH341A_CMD_I2C_STM_STA  =  0x74
mCH341A_CMD_I2C_STM_STO  =  0x75
mCH341A_CMD_I2C_STM_OUT  =  0x80
mCH341A_CMD_I2C_STM_IN   =  0xC0
mCH341A_CMD_I2C_STM_SET  =  0x60
mCH341A_CMD_I2C_STM_US   =  0x40
mCH341A_CMD_I2C_STM_MS   =  0x50
mCH341A_CMD_I2C_STM_DLY  =  0x0F
mCH341A_CMD_I2C_STM_END  =  0x00

mCH341A_CMD_UIO_STM_IN   =  0x00
mCH341A_CMD_UIO_STM_DIR  =  0x40
mCH341A_CMD_UIO_STM_OUT  =  0x80
mCH341A_CMD_UIO_STM_US   =  0xC0
mCH341A_CMD_UIO_STM_END  =  0x20


;//*************************************************
if 0

typedef		VOID	( CALLBACK	* mPCH341_INT_ROUTINE ) ( ULONG	iStatus );

HANDLE	WINAPI	CH341OpenDevice(ULONG iIndex );
VOID	  WINAPI	CH341CloseDevice(ULONG iIndex );
ULONG	 WINAPI	CH341GetVersion( );

ULONG	 WINAPI	CH341DriverCommand( ULONG iIndex, mPWIN32_COMMAND ioCommand );
ULONG	 WINAPI	CH341GetDrvVersion();
BOOL	  WINAPI	CH341ResetDevice( ULONG iIndex );
BOOL	  WINAPI	CH341GetDeviceDescr(ULONG iIndex, PVOID	oBuffer, PULONG	ioLength );
BOOL	  WINAPI	CH341GetConfigDescr( ULONG iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341SetIntRoutine( ULONG iIndex, mPCH341_INT_ROUTINE iIntRoutine );
BOOL	  WINAPI	CH341ReadInter(	ULONG iIndex, PULONG iStatus );
BOOL	  WINAPI	CH341AbortInter( ULONG iIndex );
BOOL	  WINAPI	CH341SetParaMode( ULONG	iIndex, ULONG iMode );
BOOL	  WINAPI	CH341InitParallel( ULONG iIndex, ULONG iMode );
BOOL	  WINAPI	CH341ReadData0( ULONG iIndex, PVOID	oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341ReadData1(	ULONG iIndex, PVOID	oBuffer, PULONG	ioLength );
BOOL	  WINAPI	CH341AbortRead(	ULONG iIndex );
BOOL	  WINAPI	CH341WriteData0( ULONG iIndex, PVOID iBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341WriteData1( ULONG iIndex, PVOID iBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341AbortWrite( ULONG iIndex );

BOOL	  WINAPI	CH341GetStatus( ULONG iIndex, PULONG iStatus );
BOOL	  WINAPI	CH341ReadI2C( ULONG	iIndex, UCHAR iDevice, UCHAR iAddr, PUCHAR oByte );
BOOL	  WINAPI	CH341WriteI2C( ULONG iIndex, UCHAR iDevice, UCHAR iAddr, UCHAR iByte );

BOOL	  WINAPI	CH341EppReadData( ULONG	iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341EppReadAddr( ULONG	iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341EppWriteData( ULONG iIndex, PVOID iBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341EppWriteAddr( ULONG iIndex, PVOID iBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341EppSetAddr( ULONG iIndex, UCHAR iAddr );

BOOL	  WINAPI	CH341MemReadAddr0( ULONG iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341MemReadAddr1( ULONG iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341MemWriteAddr0( ULONG iIndex, PVOID	iBuffer, PULONG	ioLength );
BOOL	  WINAPI	CH341MemWriteAddr1( ULONG iIndex, PVOID	iBuffer, PULONG	ioLength );

BOOL	  WINAPI	CH341SetExclusive( ULONG iIndex, ULONG iExclusive );
BOOL	  WINAPI	CH341SetTimeout( ULONG iIndex, ULONG iWriteTimeout,	ULONG iReadTimeout );
BOOL	  WINAPI	CH341ReadData( ULONG iIndex, PVOID oBuffer, PULONG ioLength );
BOOL	  WINAPI	CH341WriteData(	ULONG iIndex, PVOID	iBuffer, PULONG	ioLength );
PVOID 	WINAPI	CH341GetDeviceName( ULONG iIndex );
ULONG	 WINAPI	CH341GetVerIC( ULONG iIndex );
BOOL	  WINAPI	CH341FlushBuffer( ULONG	iIndex );
BOOL	  WINAPI	CH341WriteRead(	ULONG iIndex, ULONG	iWriteLength, PVOID	iWriteBuffer, ULONG	iReadStep, ULONG iReadTimes, PULONG	oReadLength, PVOID	oReadBuffer );
BOOL	  WINAPI	CH341SetStream( ULONG iIndex, ULONG	iMode );
BOOL	  WINAPI	CH341SetDelaymS( ULONG iIndex, ULONG iDelay );
BOOL	  WINAPI	CH341StreamI2C( ULONG iIndex, ULONG	iWriteLength, PVOID	iWriteBuffer, ULONG	iReadLength, PVOID oReadBuffer );

typedef	enum _EEPROM_TYPE {
	ID_24C01,
	ID_24C02,
	ID_24C04,
	ID_24C08,
	ID_24C16,
	ID_24C32,
	ID_24C64,
	ID_24C128,
	ID_24C256,
	ID_24C512,
	ID_24C1024,
	ID_24C2048,
	ID_24C4096
} EEPROM_TYPE;


BOOL	WINAPI	CH341ReadEEPROM( ULONG iIndex, EEPROM_TYPE iEepromID, ULONG	iAddr, ULONG iLength, PUCHAR oBuffer );
BOOL	WINAPI	CH341WriteEEPROM( ULONG	iIndex, EEPROM_TYPE	iEepromID, ULONG iAddr, ULONG iLength, PUCHAR iBuffer );
BOOL	WINAPI	CH341GetInput( ULONG iIndex, PULONG	iStatus );
BOOL	WINAPI	CH341SetOutput( ULONG iIndex, ULONG	iEnable, ULONG iSetDirOut, ULONG iSetDataOut );
BOOL	WINAPI	CH341Set_D5_D0(	ULONG iIndex, ULONG	iSetDirOut, ULONG iSetDataOut );
BOOL	WINAPI	CH341StreamSPI3( ULONG iIndex, ULONG iChipSelect, ULONG	iLength, PVOID ioBuffer );
BOOL	WINAPI	CH341StreamSPI4( ULONG iIndex, ULONG iChipSelect, ULONG	iLength, PVOID ioBuffer );
BOOL	WINAPI	CH341StreamSPI5( ULONG iIndex, ULONG iChipSelect, ULONG	iLength, PVOID ioBuffer, PVOID ioBuffer2 );
BOOL	WINAPI	CH341BitStreamSPI( ULONG iIndex, ULONG iLength, PVOID ioBuffer );
BOOL	WINAPI	CH341SetBufUpload( ULONG iIndex, ULONG iEnableOrClear );
LONG	WINAPI	CH341QueryBufUpload( ULONG iIndex );
BOOL	WINAPI	CH341SetBufDownload( ULONG iIndex, ULONG iEnableOrClear );
LONG	WINAPI	CH341QueryBufDownload( ULONG iIndex );
BOOL	WINAPI	CH341ResetInter( ULONG iIndex );
BOOL	WINAPI	CH341ResetRead( ULONG iIndex );
BOOL	WINAPI	CH341ResetWrite( ULONG iIndex );

typedef		VOID	( CALLBACK	* mPCH341_NOTIFY_ROUTINE ) ( ULONG iEventStatus );

BOOL	WINAPI	CH341SetDeviceNotify( ULONG	iIndex, PCHAR iDeviceID, mPCH341_NOTIFY_ROUTINE	iNotifyRoutine );
BOOL	WINAPI	CH341SetupSerial( ULONG	iIndex, ULONG iParityMode, ULONG iBaudRate );

end if













